<?php
namespace Neklo\Scheduler\Controller\Adminhtml\Schedule;

use Neklo\Scheduler\Controller\Adminhtml;
use Neklo\Scheduler\Api\Data\SchedulerInterface;

class Delete extends Adminhtml\Operation
{
    public function execute()
    {
        try {
            $data = $this->getRequest()
                ->getParam(SchedulerInterface::SCHEDULE_ID);
            if ($data) {
                /* @var $model \Magento\Cron\Model\Schedule */
                $model = $this->_objectManager
                    ->create('Magento\Cron\Model\Schedule');
                $model->load($data);
                if ($model->getId()) {
                    $name = $model->getJobCode();
                    $time = $model->getScheduledAt();
                    $model->delete($model);
                    $this->messageManager->addSuccess(
                        __('Schedule %1 at %2 removed', $name, $time));
                }
            } else {
                $this->messageManager->addError(__('Data ID missing - error'));
            }
        } catch (\Exception $e) {
            $this->log->critical($e->getMessage());
            $this->messageManager->addError(__('Operation error'));
        }
        return $this->_redirect(static::REDIRECT_URL);
    }

}
